#ifndef __DGLUTIL_HPP__
#define __DGLUTIL_HPP__

#include <GLUT/glut.h>

namespace DECS{
  namespace GL{

    static const int X = 0;
    static const int Y = 1;
    static const int Z = 2;
    static const int R = 0;
    static const int G = 1;
    static const int B = 2;
    static const int A = 3;

    class DGLColor{
    private:
      GLdouble color_[4];
    public:
      DGLColor();
      DGLColor(GLdouble r, GLdouble g, GLdouble b);
      DGLColor(GLdouble r, GLdouble g, GLdouble b, GLdouble a);
      ~DGLColor();

      GLdouble r();
      GLdouble g();
      GLdouble b();
      GLdouble a();
    };

    class DGLPosition{
    private:
      GLdouble position_[3];
    public:
      DGLPosition();
      DGLPosition(GLdouble x, GLdouble y, GLdouble z);
      ~DGLPosition();

      GLdouble& x();
      GLdouble& y();
      GLdouble& z();
    };
  }
}

#endif // __DGLUTIL_HPP__
