#include <GL/dglutil.hpp>

namespace DECS{
  namespace GL{
    DGLColor::DGLColor()
    {
      this->color_[R] = 0.0;
      this->color_[G] = 0.0;
      this->color_[B] = 0.0;
      this->color_[A] = 1.0;
    }

    DGLColor::DGLColor(GLdouble r, GLdouble g, GLdouble b)
    {
      this->color_[R] = r;
      this->color_[G] = g;
      this->color_[B] = b;
    }

    DGLColor::DGLColor(GLdouble r, GLdouble g, GLdouble b, GLdouble a)
    {
      this->color_[R] = r;
      this->color_[G] = g;
      this->color_[B] = b;
      this->color_[A] = a;
    }

    DGLColor::~DGLColor()
    {
    }

    GLdouble DGLColor::r()
    {
      return this->color_[R];
    }

    GLdouble DGLColor::g()
    {
      return this->color_[G];
    }

    GLdouble DGLColor::b()
    {
      return this->color_[B];
    }

    GLdouble DGLColor::a()
    {
      return this->color_[A];
    }

    DGLPosition::DGLPosition()
    {
      this->position_[X] = 0.0;
      this->position_[Y] = 0.0;
      this->position_[Z] = 0.0;
    }

    DGLPosition::DGLPosition(GLdouble x, GLdouble y, GLdouble z)
    {
      this->position_[X] = x;
      this->position_[Y] = y;
      this->position_[Z] = z;
    }

    DGLPosition::~DGLPosition()
    {
    }

    GLdouble& DGLPosition::x()
    {
      return this->position_[X];
    }

    GLdouble& DGLPosition::y()
    {
      return this->position_[Y];
    }

    GLdouble& DGLPosition::z()
    {
      return this->position_[Z];
    }
  }
}
